#ifndef USBEZUSB_H
#define USBEZUSB_H

// EZ-USB Control and Status Register. bit 0 bestuurt 8051 reset
#define CPUCS_REG_EZUSB 0x7F92

// dit is het hoogste interne RAM geheugenadres voor de AN2131Q
#define MAX_INTERNAL_ADDRESS  0x1B3F

#define INTERNAL_RAM(address) (((address) <= MAX_INTERNAL_ADDRESS) ? 1 : 0)

// This one is implemented in the core
#define ANCHOR_LOAD_INTERNAL  0xA0

NTSTATUS
Ezusb8051Reset(
   PDEVICE_OBJECT DeviceObject,
   UCHAR resetBit
   );
NTSTATUS
EzusbAnchorDownload(
   PDEVICE_OBJECT DeviceObject,
   WORD offset,
   PUCHAR downloadBuffer,
   ULONG downloadSize
   );

#endif // USBEZUSB_H
