#ifndef USBGETDESCRIPTOR_H
#define USBGETDESCRIPTOR_H

ULONG
UsbGetDescriptorWithIndexAndLanguage(
    IN PDEVICE_OBJECT DeviceObject,
    PVOID             pOutputBuffer,
    ULONG             ulOutputBufferLength,
    UCHAR             DescriptorType,
    UCHAR             Index,
    USHORT            LanguageId
    );
PUSB_CONFIGURATION_DESCRIPTOR
UsbGetConfigDescriptor(
    IN PDEVICE_OBJECT DeviceObject
    );

#define UsbGetStringDescriptor(DeviceObject, pOutputBuffer, ulOutputBufferLength, Index, LanguageId) \
   UsbGetDescriptorWithIndexAndLanguage( \
      (DeviceObject), (pOutputBuffer), (ulOutputBufferLength), USB_STRING_DESCRIPTOR_TYPE, \
      (Index), (LanguageId) \
   )

#define UsbGetDescriptor(DeviceObject, pOutputBuffer, ulOutputBufferLength, DescriptorType) \
   UsbGetDescriptorWithIndexAndLanguage( \
      (DeviceObject), (pOutputBuffer), (ulOutputBufferLength), (DescriptorType), \
      0, 0 \
   )

#define UsbGetDeviceDescriptor(DeviceObject, pOutputBuffer, ulOutputBufferLength) \
   UsbGetDescriptor( \
      (DeviceObject), (pOutputBuffer), (ulOutputBufferLength), USB_DEVICE_DESCRIPTOR_TYPE, \
   )

#endif // USBGETDESCRIPTOR_H
