#ifndef USBREQUESTS_H
#define USBREQUESTS_H

typedef struct _SET_FEATURE_CONTROL
{
   USHORT FeatureSelector;
   USHORT Index;
} SET_FEATURE_CONTROL, *PSET_FEATURE_CONTROL;

typedef struct _VENDOR_REQUEST_IN
{
    BYTE    bRequest;
    WORD    wValue;
    WORD    wIndex;
    WORD    wLength;
    BYTE    direction;
    BYTE    bData;
} VENDOR_REQUEST_IN, *PVENDOR_REQUEST_IN;

NTSTATUS
UsbSelectInterfaces(
    IN PDEVICE_OBJECT DeviceObject,
    IN PUSB_CONFIGURATION_DESCRIPTOR ConfigurationDescriptor,
    IN PUSBD_INTERFACE_INFORMATION Interface
    );
NTSTATUS
UsbConfigureDevice(
    IN  PDEVICE_OBJECT DeviceObject
    );
NTSTATUS
UsbSetInterface(
   IN PDEVICE_OBJECT DeviceObject,
   IN UCHAR InterfaceNumber,
   IN UCHAR AlternateSetting
   );
NTSTATUS
UsbSetFeature(
   IN PDEVICE_OBJECT DeviceObject,
   IN PSET_FEATURE_CONTROL setFeatureControl
   );
NTSTATUS
UsbResetPipe(
   IN PDEVICE_OBJECT DeviceObject,
   IN ULONG PipeNum
   );
NTSTATUS
UsbAbortPipe(
    IN PDEVICE_OBJECT DeviceObject,
    IN USBD_PIPE_HANDLE PipeHandle
    );
ULONG
UsbVendorRequest(
    IN PDEVICE_OBJECT DeviceObject,
    PVENDOR_REQUEST_IN pVendorRequest
    );
NTSTATUS
UsbVendorRequestMDL(
   IN PDEVICE_OBJECT DeviceObject,
   IN PIRP Irp
   );
NTSTATUS
UsbTransfer(
   IN  PDEVICE_OBJECT DeviceObject,
   IN  PIRP Irp
   );

#endif // USBREQUESTS_H
